=begin
------------------------------------------------------------------------
Copyright 2007, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name:          	default_all_layers.rb
Description:   	Defaults all layers for all selected objects.
Author:       	TIG
Usage:			1. Select one of more entities. 
				2. Activate the script from the Plugins Menu  
History:		1.0 20070825	First issue.
            1.1 20080309  Typo fixed in selection check ! Sorry...
            1.2 20080309  Second Typo fixed in menus !  Double sorry !
=end
#-----------------------------------------------------------------------------
require 'sketchup.rb' 
class DefaultAllLayers 
  def to_default(entity)  
    entity.definition.entities.each{|e|to_default(e)}if entity.typename=="ComponentInstance"
    entity.entities.each{|e|to_default(e)}if entity.typename=="Group"
    entity.layer=nil
  end#def to_default 
  def process() ; 
    Sketchup.active_model.selection.each{|e|to_default(e)} 
  end#def process 
end#class RemoveLayers
def default_all_layers
  if not Sketchup.active_model.selection[0] 
    UI.messagebox("Default All Layers:\nSelect Objects BEFORE Running.")
    return nil
  end#if
  Sketchup.active_model.start_operation("Default All Layers")
   DefaultAllLayers.new.process
  Sketchup.active_model.commit_operation
end#def
#-----------------------------------------------------------------------
is_this_file=File.basename(__FILE__)
if not file_loaded?(is_this_file)
    UI.menu("Plugins").add_item("Default All Layers") {default_all_layers}
end#if
#-----------------------------------------------------------------------
file_loaded(is_this_file)
